#   Descrip.mms makefile for ZLib on OpenVMS
#
#   Modified:  7-APR-2000 Rick Dyson (rick-dyson@uiowa.edu)

ZLIB = [-.Z]

OPTIMIZE = /Optimize
DEBUG = /NoDebug
DEFS = /Prefix = All
INCS = /Include = $(ZLIB)

CFLAGS = /DECC $(DEFS) $(OPTIMIZE) $(DEBUG) /NoList $(INCS)
LINKFLAGS = $(LINKFLAGS) $(DEBUG)

OBJS =  png.obj pngset.obj pngget.obj pngrutil.obj pngtrans.obj \
	pngwutil.obj pngread.obj pngmem.obj pngwrite.obj pngrtran.obj \
	pngwtran.obj pngrio.obj pngwio.obj pngerror.obj pngpread.obj

all :	pngtest.exe libpng.olb
	@ write sys$output "PNGtest available"

lib : 	libpng.olb
	@ write sys$output "LibPNG build complete..."

#libpng.olb :	libpng.olb($(OBJS))
#	@ Continue

libpng.olb :	$(OBJS)
	Library /Create libpng.olb *.obj
	Set File /Truncate libpng.olb

pngtest.exe :	pngtest.obj libpng.olb
	$(LINK) $(LINKFLAGS) pngtest,LibPNG.olb/Library,$(ZLIB)LibZ.olb/Library

test :	pngtest.exe
	Run PNGtest

clean :
	@- Set Message /NoIdentification /NoText /NoSeverity /NoFacility
	@- Set Protection = Owner:RWED *.*;*
	- Purge /NoLog /NoConfirm *.mms,*.obj,*.exe
	@- Set Protection = Owner:RWE *.*
	@- Set Message /Identification /Text /Severity /Facility

clobber :	clean
	@- Set Message /NoIdentification /NoText /NoSeverity /NoFacility
	@- Set Protection = Owner:RWED *.*;*
	- Delete /NoLog /NoConfirm *.olb;,*.obj;,*.exe;
	@- Set Protection = Owner:RWE *.*
	@- Set Message /Identification /Text /Severity /Facility

# Other dependencies.
png.obj : png.h, pngconf.h
pngpread.obj : png.h, pngconf.h
pngset.obj : png.h, pngconf.h
pngget.obj : png.h, pngconf.h
pngread.obj : png.h, pngconf.h
pngrtran.obj : png.h, pngconf.h
pngrutil.obj : png.h, pngconf.h
pngerror.obj : png.h, pngconf.h
pngmem.obj : png.h, pngconf.h
pngrio.obj : png.h, pngconf.h
pngwio.obj : png.h, pngconf.h
pngtest.obj : png.h, pngconf.h
pngtrans.obj : png.h, pngconf.h
pngwrite.obj : png.h, pngconf.h
pngwtran.obj : png.h, pngconf.h
pngwutil.obj : png.h, pngconf.h
